/*
btputhx.c Version 0.1.0  Btree print 16 bytes in hex
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void btputhx(adr,len,str)
int adr;
int len;
unsigned char *str;
   {
   unsigned char *p,*q,*r;
   printf("%06x  ", adr);
   p = str;
   q = str + 4;
   r = str + len;
   while (p < q)
      {
      if (p < r)
	 printf("%02x", *p);
      else
	 printf("  ");
      p++;
      } /* first 4 */
   putchar(' ');
   q += 4;
   while (p < q)
      {
      if (p < r)
	 printf("%02x", *p);
      else
	 printf("  ");
      p++;
      } /* first 4 */
   printf("  ");
   q += 4;
   while (p < q)
      {
      if (p < r)
	 printf("%02x", *p);
      else
	 printf("  ");
      p++;
      } /* first 4 */
   putchar(' ');
   q += 4;
   while (p < q)
      {
      if (p < r)
	 printf("%02x", *p);
      else
	 printf("  ");
      p++;
      } /* first 4 */
   printf("  *");
   p = str;
   q = str + 16;
   while (p < q)
      {
      if (p < r)
	 {
	 if (*p < ' ' || *p > '~')
	    putchar(' ');
	 else
	    putchar(*p);
	 } /* if within len */
      else
	 putchar(' ');
      p++;
      } /* for each of 16 */
   putchar('*');
   putchar('\n');
   } /* btputhx */
